<?php

namespace App\Http\Requests\Admin;

use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;

class AttributeRequest extends FormRequest
{

    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        if (! Auth::check()) {
            return false;
        }
        if(in_array(Auth::user()->role, ['super_admin', 'admin']))
        {
            return true;
        }

        if(Auth::user()->hasModule('attributes'))
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $rules=[
//            'status' => 'required|in:multi,one',
//            'type' => 'required|in:main,sub',
        ];
//        if(request('type'))
//        {
//            if(request('type') == 'sub')
//            {
//                $rules['attribute_id'] = 'required|exists:attributes,id';
//                $rules['choice_id'] = 'required|exists:attribute_choices,id';
//            }
//        }
        foreach (languages() as $lang)
        {
            $lang_rules =
                [
                    'name_'.$lang->local=> 'required',
                ];
            $rules= array_merge($rules, $lang_rules);
        }
        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {

        $field = metaFields('attributes');
        $attributes= [
            'count_status' => __('attributes.count_status'),
            'image_status' => __('attributes.image_status'),
            'show_status' => __('attributes.show_status'),
            'attribute_id' => __('attributes.attribute_id'),
        ];
        if( !is_null( request('choices') ) )
        {
            foreach(request('choices') as $key=>$choice)
            {
                foreach (languages() as $lang) {
                    $choiceTitle =
                        [
                            'choices.'.$key.'.name_'.$lang->local =>  __('attributes.name') .' '.$lang->local .' '.($key+1),
                        ];
                    $attributes = array_merge($attributes, $choiceTitle);
                }

            }
        }

        foreach (languages() as $lang) {
            $lang_attributes=[
                'name_'.$lang->local =>  __('attributes.name') .' '.$lang->local,
            ];
            $attributes= array_merge($attributes, $lang_attributes);
        }
        return $attributes;
    }


    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests

        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            // Do the original action of the Form request class
            parent::failedValidation($validator);
        }
    }
}
